/***************************************************************************** 
* Get a selection buffer
*****************************************************************************/

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/Xos.h>
#include <X11/extensions/shape.h>
#include <stdio.h>

Display     *dpy;


int getselection(char **sel, int isel) {

  int                nbytes;
  char               *display_name=NULL;
  void               nferrormsg(char *, ...);
  

  /* Connect to X server */
  if ((dpy = XOpenDisplay(display_name)) == NULL) {
    nferrormsg("mvreswin(): Couldn't connect to X server %s!", 
	       XDisplayName(display_name));
    return 0;
  }

  *sel = XFetchBuffer(dpy, &nbytes, isel);

  /* Disconnect from X server */
  XCloseDisplay(dpy);

  return 1;
}
